; zusammenstellen ROM fr Propeller-Tiny
; Version 2.0Beta, Uwe Nickel 2012
; orig: 4krom.bin

; bentigt U883-ROM + orig. ROMs fr ES1988
; patcht Bilderzeugung, Kassetten-I/O, plus 3 neue Systemkommandos

; reass. 22.01.2024 Volker Pohlers


		cpu	z8601
		include stddefz8.inc
		assume RP:0C0h

; AS-Funktionen
hi	function x,(x>>8)&255
lo	function x, x&255


emu	equ	0	; 1 - lauf im jtcemu

;------------------------------------------------------------------------------
; 0000-07FF U883_MME_BAS
;------------------------------------------------------------------------------

		org	0
		binclude U883_MME_BAS.bin

	if emu=0
;Patches
		org	000ch
init:
;; entfllt
;;		srp	#0		; Registerprointer auf 00-Gruppe
;;		ld	R3, #0Fh	; Test,	ob P32 und P35 gebrckt	sind
;;		nop
;;		tm	R3, #4
;;		ld	R3, #0FFh
;;		jr	NZ, init10
;;		tm	R3, #4
;;		jr	NZ, test	; wenn gebrckt, dann weiter im	Test-Programm

		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop

	endif
		
;------------------------------------------------------------------------------
; 0800-0FFF ES_4K ROM1
;------------------------------------------------------------------------------

		org	800h
		binclude es_4k_1.bin

	if emu=0
; patches
		org	0ADAh
; Videoanzeige macht der Prop. Hier muss nix mehr erfolgen
IRQ4_Handler:				; Port 2
		inc	p2
		iret
		db	127 dup(0FFh)	
	
	endif	

;------------------------------------------------------------------------------
; 1000-17FF Zusatz
;------------------------------------------------------------------------------

TBS:		equ	0824h
ZBS:		equ	0827h	; Ausgabe Zeichen
CLS:		equ	08DDh	; Bildschirm lschen
NLE:		equ	0ACEh
PrtTxt1:	equ	0BFAh
TSK:		equ	0C1Dh
loc_204E	equ	204Eh	; Komandoscheife Fortsetzung
ES_PrHex	equ	20B6h
ES_PrMemByt	equ	20CFh
ES_GetHexWrd	equ	231Fh
ES_Prog		equ	23E4h
ES_Save1	equ	268Fh
ES_Save		equ	26ADh

		org 1000h

; ---------------------------------------------------------------------------
; Erweiterung Kommandos
; ---------------------------------------------------------------------------

ES_BeginX:	jp	Z, ES_Prog
		cp	5Ah, #'D'
		jr	NZ, loc_100B
		call	xdir		; D - Directory
;
loc_100B:	cp	5Ah, #'C'
		jr	NZ, loc_1013
		call	xcall		; C - Call HexAdr.
;
loc_1013:	cp	5Ah, #'X'
		jr	NZ, loc_101B
		call	xdel		; X - Delete File
;
loc_101B:	;... frei
		jp	loc_204E	; Komandoscheife Fortsetzung

; Texttabelle, Trenner Zeichen mit gesetztem  7. Bit
TxtTab2:	DB 'E'+80h,"RROR"	; #01
		DB ' '+80h,"*DELETE*"	; #02
		DB ' '+80h,"SURE?(Y/N)"	; #03

		db 0Ch+80h, " EMR-ES 1988", 0Dh, " ", 0Dh ; #04
		db "B BASIC", 0Dh
		db "I INIT", 0Dh
		db "S SAVE X DEL",0Dh
		db "L LOAD D DIR", 0Dh
		db "R DATA C CALL",0Dh
		db "P PROG"
		DB ' '+80h

; ---------------------------------------------------------------------------
; C - Call HexAdr.
; ---------------------------------------------------------------------------

xcall:		dec	5Bh		; Cursorposition
		push	rp		; Register pointer
		srp	#60h
		call	ES_GetHexWrd	; Hexadezimaleingabe eines Doppelbytes
		pop	rp		; Register pointer
		jp	@6Eh		; Wort aus Hex-Eingabe

; ---------------------------------------------------------------------------
; Anzeige DIR
; UP zu xdir2
sub_104D:	ld	R0, #0FCh	; Magnetbandpuffer FC00-FC7F
		ld	R1, #0
		ld	R8, #7		; Anz Zeilen
loc_1053:	ld	R2, #13		; Zeichen/Zeile
loc_1055:	lde	R3, @RR0
		ld	5Ah, R3		; ins ASCII-bergaberegister
		call	ZBS		; und Ausgabe Zeichen
		incw	RR0
		djnz	R2, loc_1055
		call	NLE		; neue Bildschirmzeile
		djnz	R8, loc_1053
		ret

; ---------------------------------------------------------------------------
; Buffer leeren
; UP zu xdir2
sub_1066:	ld	R0, #0FCh	; Magnetbandpuffer FC00-FC7F
		ld	R1, #0
		ld	R2, #7Fh	; 127 Byte
		ld	R3, #0
loc_106E:	lde	@RR0, R3	; mit 00 fllen
		incw	RR0
		djnz	R2, loc_106E
		ret

; ---------------------------------------------------------------------------
; D - Directory
; ---------------------------------------------------------------------------

xdir:		call	CLS		; Bildschirm lschen
		call	sub_2731	; Open SD Card
		jr	C, xdir1	; weiter wenn KEIN Fehler
		ret
;
xdir1:		push	rp		; Register pointer
		srp	#50h
xdir2:		call	CLS		; Bildschirm lschen
		call	sub_1066	; Buffer leeren
		ld	R13, #14h	; kdo $14 - Directory laden
		call	sub_2718	; Prop-Kommando ausfhren
		call	sub_104D	; Anzeige 7 Eintrge
		call	TSK		; Tastenabfrage
		cp	5Ah, #7Fh
		jr	Z, xdir3	; wenn Ende
		cp	p1, #0		; Port 1 Kdo Rckgabewert
		jr	Z, xdir2	; =0, dann weiter listen
xdir3:		pop	rp		; Register pointer
		jp	loc_273C	; Close SD Card

; ---------------------------------------------------------------------------
; X - Delete File
; ---------------------------------------------------------------------------

xdel:		call	CLS
		ld	58h, #2		; *DELETE*
		call	PrtTextX	; Text ausgeben
		call	sub_2731	; Open SD Card
		jr	C, xdel1	; weiter wenn KEIN Fehler
		ret
;
xdel1:		call	ES_Save
		call	sub_10C8	; Abfrage Sure?
		jr	NC, xdel2	; Abbruch bei 'N'
		call	NLE		; neue Bildschirmzeile
		ld	5Dh, #15h	; kdo $15 - Datei lschen
		call	sub_2718	; Prop-Kommando ausfhren
		jr	C, xdel2	; weiter wenn KEIN Fehler
		ret
;
xdel2:		jp	loc_273C	; Close SD Card

; ---------------------------------------------------------------------------

sub_10C8:	ld	5Bh, #50h	; Setze Cursorposition
		ld	58h, #3		; Sure Y/N?
		call	PrtTextX	; Text ausgeben
		call	TSK		; Tastenabfrage
		cp	5Ah, #'Y'
		scf
		jr	Z, locret_10E0	; Y -> Cy=1
		cp	5Ah, #'N'
		jr	NZ, sub_10C8
		rcf			; N -> Cy=0
locret_10E0:	ret


;------------------------------------------------------------------------------
; 2000-27FF ES_4K ROM2
;------------------------------------------------------------------------------

		org 1C00h
		binclude baserw2k.bin


		org 2000h
		binclude es_4k_2.bin

	if 1=1
		
; patches

		org 201Fh	; 201F - 2026
;ES_BgLp	ld 58h, R12		; Text 4..1 fr Startmen
;		call PrtText3		;  am Bildschirm ausgeben
;		djnz R12, ES_BgLp

		ld 58h, #4
		call PrtTextX
		nop

	endif

; Kommandoscheife erweitern
		org	204Bh
;;		jp Z, ES_Prog
		jp	ES_BeginX

;; Magnetbandausgabe
		org	268Fh
;;ES_Save1	call CLS
		jp	sub_2744
; Restcode bleibt bis hinter ES_Save6
; Start- und Endeadresse, Name afragen
; Puffer lschen
; vor dem eigentlichen Schreiben ist
; in ES_Save6 RET eingepatcht

		org	26E1h
; mitten in ES_Save6:
		ret

; ---------------------------------------------------------------------------

; ---------------------------------------------------------------------------
; Ausgabe Text
sub_2700:	ld	58h, #1		; "Error"
;
PrtTextX:	push	rp		; Register pointer
		srp	#50h
		ld	R14, #hi(TxtTab2)	; texttabelle
		ld	R15, #lo(TxtTab2)
		jp	PrtTxt1

; ---------------------------------------------------------------------------
; Ausgabe Fehlercode
sub_270E:	call	sub_2700	; Textausgabe "Error" 
		ld	5Dh, p1		; Port 1 Rckgabewert
		call	ES_PrHex	; Ausgabe Fehlercode
		ret

; ---------------------------------------------------------------------------
; Prop-Kommando ausfhren
; in 5Dh - Kommando (s.tinyemu.doc)
; ret Cy=0 Fehler, Cy=1 KEIN Fehler

sub_2718:	ld	p1, #0		; Port 1 Kdo-Parameter := 0
sub_271B:	ld	p0, 5Dh		; Port 0 Kdo senden
loc_271E:	cp	p0, 5Dh		; Port 0 warten bis fertig
		jr	Z, loc_271E
		cp	p1, #10h	; Port 1 Rckgabewert
		nop
		jr	C, locret_2730	; wenn < 10h, kein echter Fehler
					; dann Ende, sonst
		call	sub_270E	; Ausgabe Fehlercode
		call	TBS
		rcf			; Cy=0
locret_2730:	ret

; ---------------------------------------------------------------------------
; Open SD Card
sub_2731:	ld	5Dh, #10h	; kdo $10 - SD-Card mounten
		call	sub_2718	; Prop-Kommando ausfhren
		jr	C, locret_2743
		ld	p1, #4		; Port 1 Kdo-Parameter := 4
; Close SD Card
loc_273C:	ld	5Dh, #1Fh	; kdo $1F - SD-Card stoppen
		call	sub_271B	; Prop-Kommando ausfhren
		rcf
locret_2743:	ret

; ---------------------------------------------------------------------------
; ES_Save1 NEU

sub_2744:	call	CLS		; Bildschirm lschen
		call	sub_2731	; Open SD Card
		jr	NC, locret_2743	; Abbruch bei Fehler
		call	ES_Save1+3	; weiter hinter Patch:
					; Start- und Endeadresse, Name afragen
					; Puffer lschen
					; vor dem eigentlichen Schreiben ist
					; in ES_Save6 RET eingepatcht
					; damit geht es hier weiter
		ld	5Dh, #11h	; kdo $11 - Datei speichern
		call	sub_2718	; Prop-Kommando ausfhren
		jr	loc_273C	; Close SD Card

; ---------------------------------------------------------------------------
; Adresse ggf. ndern
; in RR2 = Adr. auf Bildschirm

sub_2760:	push	rp		; Register pointer
		srp	#50h
loc_2764:	push	5Bh		; rette Cursorposition
		push	rp		; Register pointer
		srp	#60h
		call	ES_GetHexWrd	; Hexadezimaleingabe
		pop	rp		; Register pointer
		jr	NC, loc_277A
		cp	5Ah, #0Dh	; ENTER?
		jr	Z, loc_2784	; ja -> Ende
		pop	5Bh		; setze Cursorposition
		jr	loc_2764
;
loc_277A:	ld	R0, 6Eh		; eingegebener Wert
		ld	R1, 6Fh
		lde	@RR2, R1	; Wert nach (RR2)
		incw	RR2
		lde	@RR2, R0
loc_2784:	pop	5Ch
		pop	rp		; Register pointer
		ret

; ---------------------------------------------------------------------------
; Anzeige Adressen aus Header

sub_2789:	push	rp		; Register pointer
		srp	#50h
		ld	R14, #0FCh
		ld	R15, #12h	; FC12 = hi(aadr)
		call	ES_PrMemByt
		ld	R15, #11h	; FC11 = lo(aadr)
		call	ES_PrMemByt
		inc	5Bh		; Cursorposition
		ld	R15, #14h	; FC14 = hi(eadr)
		call	ES_PrMemByt
		ld	R15, #13h	; FC13 = lo(eadr)
		call	ES_PrMemByt
		pop	rp		; Register pointer
		ret

; ---------------------------------------------------------------------------

sub_27A8:	ld	5Bh, #30h	; setze Cursorposition
		push	5Bh		; rette Cursorposition
		call	sub_2789	; Anzeige Aadr, Eadr
		pop	5Bh		; setze Cursorposition
		push	rp		; Register pointer
		srp	#50h
		ld	R2, #0FCh	; FC11/12=aadr
		ld	R3, #11h
		call	sub_2760	; Adresse ggf. ndern
		inc	5Bh		; Cursorposition
		ld	R3, #13h	; FC13/14=aadreadr
		call	sub_2760	; Adresse ggf. ndern
		pop	rp		; Register pointer
		ret


; ---------------------------------------------------------------------------
; Magnetbandeingabe 
		org	27D1h
; ES_Load1 berpatcht

ES_Load1:	call	CLS		; Bildschirm lschen
		call	sub_2731	; Open SD Card
		jr	C, loc_27DA	; weiter wenn KEIN Fehler
		ret
;
loc_27DA:	call	ES_Save		; Abfrage Programmname
					; Puffer lschen
					; vor dem eigentlichen Schreiben ist
					; in ES_Save6 RET eingepatcht
					; damit geht es hier weiter
loc_27DD:	ld	5Dh, #12h	; kdo $12 - Datei-Header einlesen in Puffer ab $FC00
		call	sub_2718	; Prop-Kommando ausfhren
		jr	C, loc_27E6	; weiter wenn KEIN Fehler
		ret
;
loc_27E6:	call	sub_27A8
		call	sub_2731	; Open SD Card
		jr	C, loc_27EF	; weiter wenn KEIN Fehler
		ret
;
loc_27EF:	ld	5Dh, #13h	; kdo $13 - Dateiinhalt laden
		call	sub_2718	; Prop-Kommando ausfhren
		jp	loc_273C	; Close SD Card	

; ---------------------------------------------------------------------------

		db 0FFh

	message "bin2jtc.pl 4krom_vp1.bin TINY4K.SYS 0"
		
		end
