; reass: Volker Pohlers 02.2007/07.2021


;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255


		cpu	z8601
		include	stddefz8.inc
		page	0

		org	0
		assume RP:0C0h		; keine Optimierung durch AS!

reg_04		equ	4	; Hi TRAP
reg_05		equ	5	; Lo TRAP
reg_06		equ	6	; Hi Adr. Basic-Programm
reg_07		equ	7	; Lo Adr. Basic-Programm
reg_08		equ	8	; Hi Adr. ext. Prozedurliste
reg_09		equ	9	; Lo Adr. ext. Prozedurliste
reg_0A		equ	0Ah
reg_0B		equ	0Bh
reg_0C		equ	0Ch
reg_0E		equ	0Eh	; BASIC-Fehler
				; Bit0..Bit3: Verschachtelungstiefe f. GOSUB
				; Bit4 = 1: GOSUB Stackberlauf (01)
				; Bit5 = 1: return without gosub (02)
				; Bit6 = 1: Division durch Null (04)
				; Bit7 = 1: Integerberlauf (08)

reg_0F		equ	0Fh	; BASIC-Flags (aktueller State)
				; Bit 0 01: 1=ELSE
				; Bit 1 02: END
				; Bit 2 04: CONT
				; Bit 3 08: STOP, STEP
				; Bit 4 10: <
				; Bit 5 20: >
				; Bit 6 40: =
				; Bit 7 80:
				
reg_7F		equ	7Fh

;reg_20h..reg53h Variablen A..Z (Doppelregister, 16 Bit)
;ab 54h frei nutzbar, z.B. f. Stack 

; ext. Routinen
;saddrh	equ	0E000h	; startadr RAM s. init10
;saddr	equ	812h	; startadr ROM s. init10
getch	equ	815h
putch	equ	818h


; Register
gpr 		equ	0FEh	; General purpose register bzw. Stackpointer, Highteil

;-----------------------------------------------------------------------------
; 
;-----------------------------------------------------------------------------

irq0:		dw	800h
irq1:		dw	803h
irq2:		dw	806h
irq3:		dw	809h
irq4:		dw	80Ch
irq5:		dw	80Fh

;-----------------------------------------------------------------------------
; Bootstrap MODULE
; s. Kieser/Bankel Seite	228-229
;-----------------------------------------------------------------------------

		; public init
init:		srp	#0		; Registerprointer auf 00-Gruppe
		ld	R3, #0Fh	; Test,	ob P32 und P35 gebrckt	sind
		nop
		tm	R3, #4
		ld	R3, #0FFh
		jr	NZ, init10
		tm	R3, #4
		jr	NZ, test	; wenn gebrckt, dann weiter im	Test-Programm
;
init10:		ld	p01m, #10110110b ; Festlegung fr erweitertes Zeitverhalten
		ld	p3m, #00001000b	; Programmierung Port 3
		ld	R4, #8		; Test,	ob sich	auf Adresse 0812h RAM befindet
		ld	R5, #12h
		ldc	R6, @RR4
		com	R6
		ldc	@RR4, R6
		ldc	R7, @RR4
		com	R6
		ldc	@RR4, R6
		xor	R6, R7
		srp	#0F0h
		jp	NZ, 0E000h	; wenn RAM lokalisiert ist, Sprung nach	0E000h
		jp	812h		; sonst	nach Adresse 0812h springen


;-----------------------------------------------------------------------------
; Testhilfe zur	Ausgabe	von alternierenden
; Impulsen am Port P1 und P0 mit
; Triggerimpuls	an Leitung P35
;-----------------------------------------------------------------------------

test:		ld	p01m, #4	; Port P1 und P0 auf Ausgabe
		ld	tmr, #0C0h	; internen Takt	ausgeben
		ld	R0, #0FFh
		ld	R1, #0FFh
		rcf
test10:		and	R3, #0DFh	; Triggerimpuls	an Leitung P35
		or	R3, #20h
test20:		rlc	R1
		rlc	R0
		tm	R3, #4		; Abfrage fr tristate
		jr	Z, tristate
		jr	C, test20
		jr	test10
tristate:	ld	p01m, #7Fh	; Ports	0-1 mode
halt:		jr	halt		; Warteschleife

;-----------------------------------------------------------------------------
; dma MODULE
; s. Kieser/Bankel Seite	235

; Serviceroutine fr BUSREQ,
; mit BUSREQ an	P32 und
; BUSACK ans P35, beide	L-aktiv
;-----------------------------------------------------------------------------

busreq:					; Festlegung der Kodierung fr Tristate	fr Port 0 und P1
		or	reg_7F, #18h	; P01M mu in Register %7F verfgbar sein, da P01M nicht lesbar
		ld	p01m, reg_7F	; Ports	0-1 mode
		and	p3, #0DFh	; Ausgabe von BUSACK
busreq10:	tm	p3, #4		; Port 3
		jr	Z, busreq10	; Ende abwarten
		and	reg_7F, #0F7h	; Festlegung der Kodierung fr AD0..AD7	an Port	0 und Port 1
		or	p3, #20h	; BUSACK zurcknehmen
		ld	p01m, reg_7F	; wieder auf Bus gehen
		nop			; Ausfhrung (wegen Pipeline) abwarten
		iret

; Beginn TINY-MP-BASIC
; Variablen A..Z liegen in Register 20h..53h 
; Registernutzung RP = 10h
; RR0	Pointer aktuelles Zeichen in BASIC-Programm
; RR2	Y, Rckgabewert
; RR4	X, Eingabewert
; R6 	aktuelles Zeichen 


; Arithmetik: Parameter1 X R4+R5,  Rckgabewert Y R2+R3

;-----------------------------------------------------------------------------
; Y := X
;-----------------------------------------------------------------------------

p_let:		ld	R2, R4		; Y := X
		ld	R3, R5
		ret

;-----------------------------------------------------------------------------
; Y := Y + X
;-----------------------------------------------------------------------------

p_plus:		add	R3, R5		; Y := Y + X
		adc	R2, R4
		jr	OV, p_abs3
		ret

;-----------------------------------------------------------------------------
; Y := Y - X
;-----------------------------------------------------------------------------

p_minus:	sub	R3, R5		; Y := Y - X
		sbc	R2, R4
		jr	OV, p_abs3
		ret

;-----------------------------------------------------------------------------
; interne Prozedur ABS
; ABS[parameter] absoluter Betrag
;-----------------------------------------------------------------------------
; Y := ABS (X)
p_abs:		tm	R4, #80h	; X Test Vorzeichen Bit	7
		jr	Z, p_let	; Y := X
		; sonst negieren
p_abs1:		clr	R2		; Y := 0
		clr	R3
		jr	p_minus		; Y := Y - X
p_abs2:		or	reg_0F, #80h	; Bit7
p_abs3:		or	reg_0E, #80h	; Bit7 
		ret


;-----------------------------------------------------------------------------
; UP zu DIV/MULT
;-----------------------------------------------------------------------------

; ? Vorzeichen behandeln
sign:		ld	R8, R2
		xor	R8, R4
		ld	R9, #2
;
sign1:		ld	R6, R2
		ld	R7, R3
		call	p_abs		; ABS[parameter] absoluter Betrag
		ld	R4, R6
		ld	R5, R7
		djnz	R9, sign1
		ld	R6, R2
		ld	R7, R3
		clr	R2
		clr	R3
		ret

;-----------------------------------------------------------------------------
; Y := Y * X
;-----------------------------------------------------------------------------

p_mult:		call	sign
		ld	R11, #0Fh
p_mult1:	sra	R6
		rrc	R7
		jr	NC, p_mult2
		add	R3, R5
		adc	R2, R4
		jr	OV, p_abs2
p_mult2:	rlc	R5
		rlc	R4
		jr	NOV, p_mult3
		or	R6, R7
		jr	NZ, p_abs2
p_mult3:	djnz	R11, p_mult1
p_mult4:	ld	R4, R2
		ld	R5, R3
		rlc	R8
		jr	C, p_abs1
		ret

;-----------------------------------------------------------------------------
; Y := Y / X
;-----------------------------------------------------------------------------

p_div:		call	sign
		ld	R9, #10h
		rcf
		clr	R10		; RR10 = Divisionstrest = 0
		clr	R11
p_div1:		rlc	R7
		rlc	R6
		rlc	R11
		rlc	R10
		jr	C, p_div2
		cp	R4, R10
		jr	UGT, p_div3
		jr	C, p_div2
		cp	R5, R11
		jr	UGT, p_div3
p_div2:		sub	R11, R5
		sbc	R10, R4
		scf
p_div3:		djnz	R9, p_div1
		ld	R9, R4
		or	R9, R5
		jr	Z, p_div5
		rlc	R7
		rlc	R6
;
p_div4:		ld	R2, R6
		ld	R3, R7
		jr	p_mult4
;
p_div5:		call	p_div4
		or	reg_0E, #40h	; Bit6
p_div6:		or	reg_0F, #80h	; Bit7
		ret

;-----------------------------------------------------------------------------
; $-Operator
; Y := Y MOD X
;-----------------------------------------------------------------------------

p_mod:		call	p_div
		ld	R8, R2
		ld	R2, R10		; Divisonsrest
		ld	R3, R11
		jr	p_mult4

;-----------------------------------------------------------------------------
; $-Operator
; Y := Y OR X
;-----------------------------------------------------------------------------

p_or:		or	R2, R4		
		or	R3, R5
		ret

;-----------------------------------------------------------------------------
; $-Operator
; Y := Y AND X
;-----------------------------------------------------------------------------

p_and:		and	R2, R4		
		and	R3, R5
		ret

;-----------------------------------------------------------------------------
; $-Operator
; Y := Y XOR X
;-----------------------------------------------------------------------------

p_xor:		xor	R2, R4		
		xor	R3, R5
		ret

;-----------------------------------------------------------------------------
; interne Prozedur NOT
;-----------------------------------------------------------------------------
; Y := NOT X
; NOT[parameter] bitweise logische Negation

p_not:		call	p_let		; Y := X
		com	R2		; Y := NOT X
		com	R3
		ret

;-----------------------------------------------------------------------------
; Vergleich RR2 und RR4 auf <,=,>: out: reg_0F
;-----------------------------------------------------------------------------

relcmp:		and	reg_0F, #8Fh	; Bit 4..6 = 0
		cp	R2, R4
		jr	Z, relcmp3
		ld	R7, #20h
		jr	GT, relcmp2	; > Bitmaske 20h
relcmp1:	ld	R7, #10h	; < Bitmaske 10h
relcmp2:	or	reg_0F, R7
		ret
;
relcmp3:	ld	R7, #40h
		cp	R3, R5
		jr	Z, relcmp2	; = Bitmaske 40h
		ld	R7, #20h
		jr	UGT, relcmp2
		jr	relcmp1		

;-----------------------------------------------------------------------------
; UP zu c_PRINTHEX
; Konvertierung nach hexadezimal
;-----------------------------------------------------------------------------

tohex:		ld	R8, R3		; Byte->Nibble
		ld	R7, R3		; R2/R3 in R5..R8 kopieren
		ld	R6, R2		; 
		ld	R5, R2		; 
		swap	R5		; Hi Nibble in untere Tetrade
		swap	R7		; Hi Nibble in untere Tetrade
		ld	R4, #'%'
		;
		ld	R10, #4		; 4 Stellen
tohex1:		ld	R11, #15h	; Buffer
tohex2:		and	@R11, #0Fh
		add	@R11, #30h	; '0'
		cp	@R11, #3Ah	; '9'+1
		jr	C, tohex3	; wenn grer '9', dann + 7
		add	@R11, #7	; ergibt 'A'..'F'	
tohex3:		inc	R11		; nchste Ausgabepos
		djnz	R10, tohex2	; nchste Stelle
		ret

;-----------------------------------------------------------------------------
; UP zu c_PRINT
; Konvertierung nach dezimal 
;-----------------------------------------------------------------------------

todez:		ld	R4, R2
		ld	R5, R3
		call	p_abs		; absoluter Betrag
		rlc	R4
		ld	R4, #' '	; bei pos. Zahl Leerzeichen
		jr	NC, todez1
		ld	R4, #'-'	; bei neg. Zahl '-'
todez1:		ld	R11, #6		; 6 Stellen
		ld	R10, #15h	; Buffer
todez2:		clr	@R10		; leeren
		inc	R10
		djnz	R11, todez2
		;hex-> bcd
		ld	R11, #0Fh
todez3:		sra	R2
		rrc	R3
		jr	NC, todez4
		add	R7, R10
		da	R7
		adc	R6, R9
		da	R6
		adc	R5, R8
		da	R5
todez4:		add	R10, R10
		da	R10
		adc	R9, R9
		da	R9
		adc	R8, R8
		da	R8
		djnz	R11, todez3
		ld	R8, R7
		ld	R9, R7
		ld	R7, R6
		swap	R6
		swap	R8
		;bcd->ascii
		ld	R10, #5		; 5 Stellen
		jr	tohex1		; nach ASCII wandeln

;-----------------------------------------------------------------------------
; Ziffer in Result einschieben (i.e. * 16 + stelle)
; UP zu number
;-----------------------------------------------------------------------------

rotate:		swap	@R13		; Ziffer in oberes Nibble
		ld	R14, #4		; alles 4 Stellen nach links
rotate1:	rlc	@R13		; d.h. * 16
		rlc	R5
		rlc	R4
		rlc	R3
		djnz	R14, rotate1
		ret

;-----------------------------------------------------------------------------
; Konvertierung ASCII->Zahl (hex, o. dez signed)
; in: String in Konvertierungspuffer ab 16h (R6 ff) ..
; ret: RR4 = Wert
;-----------------------------------------------------------------------------

number:		ld	R13, #16h	; Konvertierungspuffer
		clr	R4		; Startwert 0
		clr	R5
		cp	R6, #'%'	; Prfix Hexzahl
		jr	NZ, number5

; Hex-Zahl
		ld	R12, #5		; max. 5 Stellen
number1:	inc	R13
		sub	@R13, #'0'
		jr	C, number4
		cp	@R13, #0Ah	; 9+1
		jr	C, number2
		sub	@R13, #11h	; A..F -> 0..5
		jr	C, number4
		add	@R13, #0Ah	; +10
		cp	@R13, #10h
		jr	NC, number4
number2:	call	rotate		; * 16 + Stelle
		djnz	R12, number1
number3:	rcf
		ret
;
number4:	cp	R12, #5
		jr	Z, number3
		ret

; Dezimalzahl
number5:	ld	R12, #6		; max. 6 Stellen
		clr	R2
		clr	R3
		cp	R6, #'-'	; Vorzeichen
		jr	NZ, number7
		inc	R2
number6:	inc	R13
number7:	sub	@R13, #'0'
		jr	C, number9	; wenn keine Ziffer mehr
		cp	@R13, #0Ah	; 9+1
		jr	NC, number9	; wenn keine Ziffer mehr
		call	rotate		; sonst zu BCD konvertieren
		djnz	R12, number6
number8:	rcf
		ret

; BCD R3R4R5 -> hex RR4
number9:	cp	R12, #6
		jr	Z, number8
		cp	R3, #4
		jr	NC, number8
		clr	R6
		clr	R7
		ld	R11, #13h
		ld	R8, #27h	; 2710h = 10000
		ld	R9, #10h
		call	number11
		inc	R11
		ld	R8, #3		; 3E8h = 1000
		ld	R9, #0E8h
		call	number10
		ld	R8, #0		; 064h = 100
		ld	R9, #64h
		call	number10
		inc	R11
		ld	R9, #0Ah	; 10
		call	number10
		ld	R9, #1		; 1
		call	number10
		ld	R4, R6
		ld	R5, R7
		rlc	R6
		jr	C, number8
		rrc	R2
		jr	NC, number13
		call	p_abs1
		ld	R4, R2
		ld	R5, R3
		jr	number13

; 
number10:	swap	@R11
number11:	ld	R10, @R11	; Stelle n
		and	R10, #0Fh
		jr	Z, number13
number12:	add	R7, R9		; RR8 = Stelligkeit
		adc	R6, R8
		djnz	R10, number12	; n mal Addieren
number13:	scf
		ret

;-----------------------------------------------------------------------------
; bei Prozeduraufruf PROC [Y1,Y2,Y3,..,Ym] = prozedurname [X1,X2,X3,..,Xn] gilt:
;	SP			returnadr. 
;	SP+2 .. SP+2n-2	n-1 	Parameter, wenn n>1
;				letzter Parameter aus Liste ist in RR4
;	SP+2n			(intern f. interpreter)
;	SP+2n+2	.. SP+2m+2n	Platz fr m-1 Ergebnisvariable, wenn m>1
;				letzter Parameter aus Liste ist in RR2 zu bergeben
;-----------------------------------------------------------------------------

;-----------------------------------------------------------------------------
; Ret.Adr. und ersten Parameter vom Stack nach R6/R7 holen
;-----------------------------------------------------------------------------

para1:		pop	R8		; RR8 Rckkehradresse dieser Routine
		pop	R9
		pop	R2		; RR2 Rckkehradresse zum Interpreter
		pop	R3
		pop	R6		; RR6 Adresse von X1
		pop	R7
		jp	@RR8		; RET

;-----------------------------------------------------------------------------
; interne Prozedur
; SETRR	[register,wert]	Doppelregister setzen
;-----------------------------------------------------------------------------

p_setrr:	call	para1		; Parameter register nach R6/R7
		ld	@R7, R4		; register (hi) := wert
		inc	R7
		jr	p_setr1

;-----------------------------------------------------------------------------
; interne Prozedur
; SETR [register,wert] Register	setzen
;-----------------------------------------------------------------------------

p_setr:		call	para1		; Parameter register nach R6/R7
p_setr1:	ld	@R7, R5		; register (lo) := wert
		jp	@RR2		; zurck zum Interpreter

;-----------------------------------------------------------------------------
; interne Prozedur
; SETEW	[adresse,wert] externes	Wort setzen
;-----------------------------------------------------------------------------

p_setew:	call	para1		; Parameter adresse nach R6/R7
		lde	@RR6, R4
		incw	RR6
		jr	p_seteb1

;-----------------------------------------------------------------------------
; interne Prozedur
; SETEB	[adresse,wert] externes	Byte setzen
;-----------------------------------------------------------------------------

p_seteb:	call	para1		; Parameter adresse nach R6/R7
p_seteb1:	lde	@RR6, R5
		jp	@RR2

;-----------------------------------------------------------------------------
; interne Prozedur
; GETRR	[register] liefert Inhalt des Doppelregisters
;-----------------------------------------------------------------------------

p_getrr:	ld	R2, @R5		
		inc	R5
		db	0Dh 		; JP FALSE mit nchstem	Befehl

;-----------------------------------------------------------------------------
; interne Prozedur
; GETR [register] liefert Inhalt des Registers 
;-----------------------------------------------------------------------------

p_getr:		clr	R2		; Hi = 0
		ld	R3, @R5
		ret

;-----------------------------------------------------------------------------
; interne Prozedur
; GETEW	[register] holt	Wortwert aus externem Speicher
;-----------------------------------------------------------------------------

p_getew:	lde	R2, @RR4	
		incw	RR4
		db	0Dh 		; JP FALSE mit nchstem	Befehl

;-----------------------------------------------------------------------------
; interne Prozedur
; GETEB	[register] holt	Bytewert aus externem Speicher 
;-----------------------------------------------------------------------------

p_geteb:	clr	R2		
		lde	R3, @RR4
		ret

;-----------------------------------------------------------------------------
; angezeigtes Zeichen lschen
;-----------------------------------------------------------------------------
; UP zu p_input6

delc:		call	delc1		; ein Zeichen zurck
		ld	R5, #' '	; mit Leerzeichen berschreiben
		call	putch		; PUT_CHAR
delc1:		ld	R5, #8		; BS
		jp	putch		; PUT_CHAR

;-----------------------------------------------------------------------------
; interne Prozedur
; ; RL[x] x links rotieren
;-----------------------------------------------------------------------------

p_rl:		rcf			; Cy = 0
		rlc	R5
		rlc	R4
		adc	R5, #0
p_rl1:		jp	p_let		; Y := X

;-----------------------------------------------------------------------------
; interne Prozedur
; RR[x]	x rechts rotieren
;-----------------------------------------------------------------------------

p_rr:		rcf			; Cy = 0
		rrc	R4
		rrc	R5
		jr	NC, p_rl1
		or	R4, #80h	; Vorzeichen lschen
		jr	p_rl1

;-----------------------------------------------------------------------------
; interne Prozedur
; INPUT	Zahleneingabe vom Terminal
;-----------------------------------------------------------------------------

p_input:	ld	R5, #'?'
		call	putch		; PUT_CHAR
p_input1:	ld	R15, #15h	; Konvertierungspuffer
p_input2:	inc	R15
		cp	R15, #1Fh
		jr	Z, p_input4
p_input3:	call	getch		; GET_CHAR
		ld	@R15, R3
		cp	R3, #0Dh	; CR
		jr	Z, p_input4
		cp	R3, #8		; BS
		jr	NZ, p_input5
		ld	R5, #' '
		call	putch		; PUT_CHAR
		dec	R15
		cp	R15, #15h
		jr	Z, p_input2
		call	delc1
		jr	p_input3
p_input4:	call	number
		jr	NC, p_input	; INPUT	Zahleneingabe vom Terminal
		jp	p_let		; Y := X
p_input5:	inc	R3
		jr	PL, p_input2
p_input6:	cp	R15, #16h
		jr	Z, p_input1
		call	delc		; angezeigtes Zeichen lschen
		dec	R15
		jr	p_input6

;-----------------------------------------------------------------------------
; Liste	der internen Prozeduren
;-----------------------------------------------------------------------------

tab_prc:	db	3,"NOT"
		dw	p_not		; NOT[parameter] bitweise logische Negation
		db	3,"ABS"
		dw	p_abs		; ABS[parameter] absoluter Betrag
		db	5,"SETRR"
		dw	p_setrr		; SETRR	[register,wert]	Doppelregister setzen
		db	4,"SETR"
		dw	p_setr		; SETR [register,wert] Register	setzen
		db	5,"SETEW"
		dw	p_setew		; SETEW	[adresse,wert] externes	Wort setzen
		db	5,"SETEB"
		dw	p_seteb		; SETEB	[adresse,wert] externes	Byte setzen
		db	5,"GETRR"
		dw	p_getrr		; GETRR	[register] liefert Inhalt des Doppelregisters
		db	4,"GETR"
		dw	p_getr		; GETR [register] liefert Inhalt des Registers
		db	5,"GETEW"
		dw	p_getew		; GETEW	[register] holt	Wortwert aus externem Speicher
		db	5,"GETEB"
		dw	p_geteb		; GETEB	[register] holt	Bytewert aus externem Speicher
		db	2,"RL"
		dw	p_rl		; RL[x]	x links	rotieren
		db	2,"RR"
		dw	p_rr		; RR[x]	x rechts rotieren
		db	5,"INPUT"
		dw	p_input		; INPUT	Zahleneingabe vom Terminal
		db	3,"GTC"
		dw	getch		; Get Char extern !
		db	3,"PTC"
		dw	putch		; Put Char extern !
		db	0FFh		; Listenende

;-----------------------------------------------------------------------------
;nchstes Zeichen aus Programmtext holen
;in: R7 Vergleichszeichen ret: Z=1 Zeichen gefunden
;-----------------------------------------------------------------------------
next_char:	ld	R15, #16h	; R15 vorbelegen fr buffer ?
		ldc	R6, @RR0	; nchstes Zeichen aus Basic-Programmcode
		incw	RR0		; Pointer weiterstellen
		cp	R6, R7		; Vergleich mit R7
		ret

;-----------------------------------------------------------------------------
; Operator in Operator-Tabelle suchen
; ret: R7 = op, RR8 = proc.addr.
;-----------------------------------------------------------------------------
oper:		ld	R10, #HI(tab_op)
		ld	R11, #LO(tab_op)
		ld	R13, #3		; 4 arithm. Operatoren
		call	oper1		; suche
		jr	Z, oper3	; Operator nicht gefunden
		cp	R6, #'$'	; Prfix logischer Operator
		jr	NZ, oper3	; Prfix stimmt nicht
		call	next_char
		ld	R13, #3		; 4 logische Operatoren
		
oper1:		; tab_op durchsuchen
		call	oper2	
		jr	Z, oper3	; wenn Operator gefunden
		djnz	R13, oper1
		;		
oper2:		ld	R12, #17h	; 3 Byte nach 17h kopieren
		ldci	@R12, @RR10	; R7 := Op
		ldci	@R12, @RR10	; RR8 := Fkt.Adresse
		ldci	@R12, @RR10
		cp	R6, R7		; Operator mit Suchwert vergleichen
oper3:		ret

;-----------------------------------------------------------------------------
; Tabelle Arithmetik-/Logik-Operatoren, s. oper
;-----------------------------------------------------------------------------

tab_op:		
		db	'+'
		dw	p_plus		; Y := Y + X
		db	'-'
		dw	p_minus		; Y := Y - X
		db	'*'
		dw	p_mult		; Y := Y * X
		db	'/'
		dw	p_div		; Y := Y / X
; $-Operatoren (mit vorausgehendem '$')
		db	'A'
		dw	p_and		; Y := Y AND X
		db	'O'
		dw	p_or		; Y := Y OR X
		db	'X'
		dw	p_xor		; Y := Y XOR X
		db	'M'
		dw	p_mod		; Y := Y MOD X


;-----------------------------------------------------------------------------
; Zeichenklassentests
;-----------------------------------------------------------------------------

;in: @R15 out: cy=1 bei Buchstaben A..Z
is_letter:	cp	@R15, #41h	; 'A'
		jr	C, is_notf
		cp	@R15, #5Bh	; 'Z'+1
		ret

;in: @R15 out: cy=1 bei Buchstaben A..Z oder Zahl 0..9
is_char:	call	is_letter
		jr	C, is_digit_ret

;in: @R15 out: cy=1 bei Zahl 0..9
is_digit:	cp	@R15, #30h	; '0'
		jr	C, is_notf
		cp	@R15, #3Ah	; '9'+1
is_digit_ret:	ret

;
is_notf:	rcf			; Cy=0
		ret

;in: @R15 out: cy=1 bei Zahl 0..F
is_hexdigit:	call	is_digit
		jr	C, is_digit_ret
		cp	@R15, #41h	; 'A'
		jr	C, is_notf
		cp	@R15, #47h	; 'F'+1
		ret

;-----------------------------------------------------------------------------
; Prozedurnamen in Proc-Tabelle suchen
; ret: Cy=gefunden, RR8=Proc-Adresse
;-----------------------------------------------------------------------------
; Aubau Tabelle:  je 1 Byte Namenslnge
;		     Procedurenamen
;		     2 Byte Adresse
;		  Ende mit Namenslnge = FFh
;-----------------------------------------------------------------------------

; zu func1
find_name:	; Suche in interner Tabelle
		ld	R2, #HI(tab_prc) 
		ld	R3, #LO(tab_prc)
		call	find_name1
		jr	C, find_name4	; Ende wenn gefunden
		; Suche in externer Tabelle
		clr	R2
		or	R2, reg_08	; HI ext. Proc-Table
		jr	Z, find_name3	; wenn 0 (= nicht vorhanden)
		ld	R3, reg_09	; LO ext. Proc-Table
;		
find_name1:	ld	R4, R0		; akt. Position Basicprogramm
		ld	R5, R1		; d.h. Procedur-Name
find_name2:	ldc	R8, @RR2	; Lnge Procedurname
		cp	R8, #0FFh	; tap_prc-Ende ?
		jr	NZ, comp_name
find_name3:	rcf
find_name4:	ret

; Namensvergleich
comp_name:	incw	RR2		; auf nchstes Zeichen Procedur-Name
		ldc	R7, @RR2	; Zeichen nach R7 f. Vergleich
		call	next_char	; gesuchte Procedur nchstes Zeichen
		jr	NZ, comp_name2	; passt nicht -> nchsten Prozedurnamen vergleichen 
		djnz	R8, comp_name	; weiter bis alle Zeichen verglichen
		; Procedur-Name in Tabelle gefunden
		ldc	R6, @RR0	; Zeichen an akt. Position Basicprogramm 	
		call	is_char		; ist der gesuchte Name lnger?
		jr	C, comp_name1	; dann weitersuchen
		incw	RR2
		ldc	R8, @RR2   	; sonst Proceduradresse nach RR8
		incw	RR2
		ldc	R9, @RR2
		scf			; Cy=gefunden
		ret
; nchsten Prozedurnamen vergleichen
comp_name1:	inc	R8		; Restlnge v. Namen + 1
comp_name2:	inc	R8		; + 2 Byte Adresse
		inc	R8
		add	R3, R8		; zu Pos in Proc-Table addieren
		adc	R2, #0
		ld	R0, R4		; akt. Position Basicprogramm 
		ld	R1, R5		; rcksetzen
		jr	find_name2	; weitersuchen

;-----------------------------------------------------------------------------
; Prozedur/Fkt.namen suchen, Eingabeparameter ablegen, Prozedur ausfhren
;-----------------------------------------------------------------------------

func:		decw	RR0

; zu c_PROC3
func1:		call	find_name	; Prozedurnamen suchen
		ldc	R10, @RR0	; Zeichen an akt. Position Basicprogramm 
		cp	R10, #'['	; folgen Eingabeparameter?
		jr	NZ, func3	; nein
		incw	RR0
		; Eingabeparameter evaluieren und auf Stack ablegen
func2:		push	R8		; Proc-Adr. sichern
		push	R9
		call	expr		; Eingabeparameter evaluieren -> RR2
		pop	R9		; Proc-Adr. restaurieren
		pop	R8
		ld	R7, #']'
		call	next_char
		jr	Z, func3	; wenn Ende Parameterliste
		push	R3		; sonst Wert auf Stack
		push	R2
		jr	func2		; und nchsten Parameter
; X1..Xn-1 liegen auf Stack, Xn in RR2
func3:		ld	R4, R2		; Y = X setzen
		ld	R5, R3
		call	@RR8		; Procedur starten
		srp	#10h		; zur Sicherheit f. ext. Proceduren
		scf			; Cy=Erfolg
		ret

;-----------------------------------------------------------------------------
; Ausdruck
; Variable, Prozedur[..], Hex-Zahl, Dez-Zahl
;-----------------------------------------------------------------------------

factor:		call	is_letter
		jr	NC, factor1	; wenn kein Buchstabe A..Z
		ldc	R7, @RR0
		inc	R15
		call	is_char		; folgt Buchstabe oder Zahl?
		jr	C, func		; ja, dann Prozedurname
		; sonst einzelne Variable A..Z
		sub	R6, #41h	; 'A'
		rl	R6		; *2
		add	R6, #20h	; Register 20h..53h
		ld	R2, @R6		; Wert nach R2/R3 (Y)
		inc	R6
		ld	R3, @R6
		scf
		ret

factor1:	cp	@R15, #';'	; Statement-Ende
		jr	Z, factor3
		cp	@R15, #0Dh	; CR, Zeilenende
		jr	Z, factor3
		inc	R15
factor2:	ldci	@R15, @RR0	; Ablegen in Konvertierungspuffer
		dec	R15
		call	is_hexdigit
		inc	R15
		jr	C, factor2	; solange (Hex-)Ziffer 0..F
		decw	RR0
		call	number		; Zahl konvertieren
		ld	R2, R4
		ld	R3, R5
factor3:	ret

;-----------------------------------------------------------------------------
; geklammerter Ausdruck
;-----------------------------------------------------------------------------

term:		ld	R7, #'('	; linke Klammer
		call	next_char
		jr	NZ, factor	; wenn keine Klammer
		call	expr		; Ausdruck berechnen
		jr	NC, term1
		ld	R7, #')'	; rechte Klammer
		call	next_char
		ccf
term1:		ret

;-----------------------------------------------------------------------------
; Ausdruck berechnen von links nach rechts (Kettenrechnen)
; Rckgabe Wert in RR2
;-----------------------------------------------------------------------------

expr:		call	term		; linker Wert
		jr	NC, expr2
expr1:		call	next_char
		call	oper		; Operator
		jr	Z, expr3	; wenn Operator gefunden
		scf			; sonst Fehler
expr2:		decw	RR0
		ret
;
expr3:		push	R8		; RR8 = Op-Fkt.Adresse
		push	R9
		push	R2		; aktueller linker Wert (Y)
		push	R3
		call	term		; rechter Wert
		ld	R4, R2		; nach RR4 (X)
		ld	R5, R3
		pop	R3		; Y restaurieren
		pop	R2
		pop	R9		; Adr. restaurieren
		pop	R8
		call	@RR8		; berechnen
;		
		jr	expr1		; weitere Operationen

;-----------------------------------------------------------------------------
; holt Speicheradresse zu Variable A..Z
; out RR8 = Adr. in Registerspeicher (20h..53h)
;-----------------------------------------------------------------------------

get_var:	call	next_char
		sub	R6, #'A'
		add	R6, R6
		ld	R8, #20h	; Register 20h..53h
		add	R8, R6
		ret

;-----------------------------------------------------------------------------
; Zeilennummer ermitteln
; ret: RR4 = zeilennummer, RR0 = Zeilenanfang; Cy=1 Programmanfang
;-----------------------------------------------------------------------------

; UP zu GOTO
linum:		;auf Zeilenanfang
		ldc	R4, @RR0
		decw	RR0		; aktuelle Zeile rckwrts
		tm	R4, #80h	; Bit7 gesetzt?
		jr	Z, linum	; rckwrts bis Zeilenanfang
		incw	RR0
		;Programmanfang erreicht?
		and	R4, #7Fh	; strip hi bit
		cp	R0, reg_06	; Vergleich Adr. mit Programmanfang
		jr	NZ, linum1	; 
		cp	R1, reg_07
		scf
		jr	Z, linum2	; Programmanfang erreicht
		;
linum1:		;steht vor gesetztem hi-bit ein CR? dann Zeilenanfang gefunden
		decw	RR0
		ldc	R5, @RR0
		incw	RR0
		cp	R5, #0Dh	; CR, Suche Zeilenende
		jr	Z, linum2	; ja, Zeilenanfang gefunden
		decw	RR0
		jr	linum		; sonst weitersuchen
		;
linum2:		incw	RR0
		ldc	R5, @RR0	; RR4=Zeilennummer
		decw	RR0
		ret

;-----------------------------------------------------------------------------
; Ausgabe "text"
;-----------------------------------------------------------------------------

prnstr:		ld	R7, #'"'
		call	next_char
		jr	NZ, prnstr2	; kein Quote -> Abbruch
prnstr1:	call	next_char	; nchstes Zeichen
		jr	Z, prnstr3	; Ende beim abschlieenden Quote
		ld	R5, R6		; nach R5
		call	putch		; mit PUT_CHAR ausgeben
		jr	prnstr1
;
prnstr2:	decw	RR0		; Pointer zurckstellen
prnstr3:	ret


;-----------------------------------------------------------------------------
; logischer Ausdruck
; expr. relop expr., ret NZ wenn true, Z wenn false
;-----------------------------------------------------------------------------

relop:	call	expr		; linker wert
		clr	R10
		ld	R9, #2		; max 2 Zeichen
relop1:		ld	R8, #10h
		ldc	R6, @RR0
		cp	R6, #'<'
		jr	Z, relop2	; < R8=10
		rl	R8
		cp	R6, #'>'
		jr	Z, relop2	; > R8=20
		rl	R8
		cp	R6, #'='
		jr	NZ, relop3	; = R8=40
relop2:		or	R10, R8		; <= R8=50, >= R8=60
		incw	RR0
		djnz	R9, relop1
		;
relop3:		push	R10
		push	R2
		push	R3
		call	expr		; rechter Wert
		ld	R4, R2		; RR4 = rechter Wert
		ld	R5, R3		
		pop	R3		; RR2 = linker Wert
		pop	R2
		call	relcmp		; Vergleich
		pop	R8
		and	R8, reg_0F	; Mit relop verknpfen
		ret			; Z=1 => relop false

;-----------------------------------------------------------------------------
; REM kommentar
;-----------------------------------------------------------------------------

c_REM:		ld	R7, #';'
c_REM1:		call	next_char
		jr	Z, c_REM2	; berlesen bis ;
		cp	R6, #0Dh	; CR
		scf
		jr	NZ, c_REM1	; oder Zeilenende
c_REM2:		decw	RR0
c_REM3:		ret


;-----------------------------------------------------------------------------
; Goto, If, Else: Rest bis Zeilenende bergehen
;-----------------------------------------------------------------------------

skip:		call	c_REM		; Rest bergehen
		jr	C, c_REM3	; Ende bei CR
		incw	RR0		; sonst auch nchste Anw.
		jr	skip		; bergehen

;-----------------------------------------------------------------------------
; LET variable=ausdruck
;-----------------------------------------------------------------------------

c_LET:		call	get_var		; @RR8 = Variablenadr.
		push	R8
		incw	RR0
		call	expr		; RR2 = ausdruck
		pop	R8
c_LET1:		ld	@R8, R2		; Wert abspeichern
		inc	R8
		ld	@R8, R3
		ret


;-----------------------------------------------------------------------------
; TRAP
; TRAP bedingung TO ausdruck
;-----------------------------------------------------------------------------
; Trap setzen
; der Rest der Anweisung wird hier bergangen

c_TRAP:		ld	reg_04, R0	; RR0 = akt. Pos. in Programm
		ld	reg_05, R1
c_TRAP1:	jr	c_REM

;-----------------------------------------------------------------------------
; PROC [variablenliste] = prozedurname [parameterliste]
; PROC [Y1,Y2,Y3,..,Ym] = prozedurname [X1,X2,X3,..,Xn]
;-----------------------------------------------------------------------------
; bei Prozeduraufruf gilt:
; Stack	SP+2m+2n	Ym-1			je 2 Byte Werte
;	..		Ym-2
;	..		..
;	SP+2n+4		Y2
;	SP+2n+2		Y1
;	SP+2n		(intern f. interpreter)
;	SP+2n-2		X1
;	..		..
;	SP+4		Xn-2
;	SP+2		Xn-1
;	SP		returnadr. zum interpreter
; die rechten Parameter Ym, Xn werden in Registern abgelegt
; out RR2 = Ym, in RR4 Xm
;-----------------------------------------------------------------------------

c_PROC:		push	reg_04		; aktuelle TRAP sichern
		push	reg_05
		ld	reg_04, R0	; aktuelle Programmposition sichern
		ld	reg_05, R1
;Ausgabeparameter auf Stack initialisieren
		ldc	R6, @RR0	; nchstes Zeichen testen
		cp	R6, #'['	; folgen Ausgabeparameter Y?
		jr	NZ, c_PROC3	; nein
		incw	RR0
		clr	R8		; 0
		ld	R7, #']'
c_PROC1:	incw	RR0
		call	next_char
		jr	Z, c_PROC2
		push	R8		; Stackspeicher f. Ausgabeparameter
		push	R8		; belegen (mit Wert 0)
		jr	c_PROC1
c_PROC2:	incw	RR0
;Prozedurnamen suchen, Eingabeparameter evaluieren und ablegen, Prozedur ausfhren
c_PROC3:	call	func1		
;Ausgabeparameter von Stack in Variablen schreiben
		ld	R0, reg_04	; Programmposition auf Anfang setzen
		ld	R1, reg_05
		ld	R7, #'['
		call	next_char
		jr	NZ, c_PROC6	; wenn keine Ausgabeparameter
		ld	R7, #']'
c_PROC4:	call	get_var		; get Variable
		call	next_char
		jr	Z, c_PROC5	; Ende bei ]
		pop	R10		; Parameter
		ld	@R8, R10	; in Variable schreiben (Hi)
		pop	R10
		inc	R8
		ld	@R8, R10	; Lo
		jr	c_PROC4		; nchsten Parameter
c_PROC5:	call	c_LET1
c_PROC6:	pop	reg_05		; TRAP wiederherstellen
		pop	reg_04
		jr	c_TRAP1

;-----------------------------------------------------------------------------
; GOTO ausdruck
;-----------------------------------------------------------------------------
; suche passende zeile oder nchstgrere; bei Programmende -> Ende

c_GOTO:		call	expr		; RR2 = ausdruck
		call	linum		; RR4 = aktuelle Zeilennummer 
		call	relcmp		; vergleichen
		tm	reg_0F, #50h	; <=
		jr	NZ, c_GOTO3	; wenn ausdruck <= akt. Zeile

c_GOTO1:	; Suche vorwrts
		call	skip		; Rest bis Zeilenende bergehen
		incw	RR0
		ldc	R4, @RR0	; RR4 = nchste Zeilennummer
		incw	RR0
		ldc	R5, @RR0
		decw	RR0
		rl	R4		; Bit7 nach Cy und Bit0
		rcf			; Cy=0
		rrc	R4		; Bit7=0, Cy=orig. Bit7
		jr	NC, c_GOTO2	; Programmende erreicht?
		call	relcmp
		tm	reg_0F, #50h	; <=
		jr	Z, c_GOTO1	; weiter, solange ausdruck <= akt. Zeile
c_GOTO2:	; Programmende erreicht
		decw	RR0
		ret

c_GOTO3:	call	linum		; RR4 = aktuelle Zeilennummer 
		jr	NC, c_GOTO4	; solange 
		
		; Wenn Zeile gefunden
		incw	gpr		; Stackpointer
		incw	gpr		; Stackpointer
		jp	run2		; Zeile abarbeiten

c_GOTO4:	; suche Rckwrts
		call	relcmp
		tm	reg_0F, #60h	; >=
		jr	NZ, c_GOTO2
		decw	RR0		; ein Zeichen zurck
		jr	c_GOTO3		; weitersuchen

;-----------------------------------------------------------------------------
; IF bedingung THEN anweisungen
;-----------------------------------------------------------------------------

c_IF:		and	reg_0F, #0FEh	; Bit0 = 0
		call	relop		; bedingung auswerten
		jr	NZ, c_IF1	; Bedinung erfllt 
					; -> nchste Anweisung abarbeiten (nach ;)
		inc	reg_0F		; Bit0 = 1 ( -> ELSE)
		jp	skip		; Rest bis Zeilenende bergehen
c_IF1:		ret

;-----------------------------------------------------------------------------
; ELSE anweisungen
;-----------------------------------------------------------------------------

c_ELSE:		tm	reg_0F, #1	; ELSE aktiv?
		jp	Z, skip		; nein, Rest bis Zeilenende bergehen
		and	reg_0F, #0FEh	; Bit0 = 0 (kein ELSE aktiv)
		ret

;-----------------------------------------------------------------------------
; RETURN
;-----------------------------------------------------------------------------

c_RETURN:	cp	reg_0E, #0	; Verschachtelungstiefe 0?
		jr	NZ, c_RETURN2	; nein
		or	reg_0E, #20h	; Bit5 = 1
c_RETURN1:	jp	p_div6		; reg_0F Bit7=1
		;
c_RETURN2:	dec	reg_0E		; Verschachtelungstiefe verringern
		pop	R6		; Return-Adr.
		pop	R7
		pop	R0		; RR0= Pos. nach GOSUB
		pop	R1
		and	reg_0F, #0FEh	; Bit0 = 0 (kein ELSE aktiv)
		jp	@RR6		; return

;-----------------------------------------------------------------------------
; GOSUB ausdruck
;-----------------------------------------------------------------------------

c_GOSUB:	ld	R8, R0		; aktuelle Position
		ld	R9, R1		; sichern
		call	c_REM		; RR0=Kommandoende
		pop	R10		; Return-Adresse vom Stack
		pop	R11
		push	R1		; Pos. nach GOSUB 
		push	R0		; auf Stack
		push	R11		; Return-Adresse restaurieren
		push	R10
		ld	R0, R8		; orig. Position
		ld	R1, R9		; rckschreiben
c_GOSUB1:	inc	reg_0E		; Verschachtelungstiefe erhhen
		tm	reg_0E, #10h	; > 15 ?
		jp	Z, c_GOTO	; nein, UP aufrufen
		; max Verschachtelungstiefe erreicht
		call	c_REM		; bis Kommandoende berlesen
		jr	c_RETURN1	; und Verschachtelungstiefe verringern

;-----------------------------------------------------------------------------
; WAIT ausdruck
; Schleifendauer 1 ms bei 8 MHz Taktfrequenz
;-----------------------------------------------------------------------------

c_WAIT:		call	expr		; RR2 = ausdruck
		ld	R6, R2
		or	R6, R3		; = 0?
		jr	Z, c_WAIT3	; dann kein Wait
c_WAIT1:	da	R6
		ld	R6, #0
		ld	R7, #0B4h
c_WAIT2:	decw	RR6
		jp	NZ, c_WAIT2
		decw	RR2
		jp	NZ, c_WAIT1
c_WAIT3:	ret

;-----------------------------------------------------------------------------
; CALL ausdruck
;-----------------------------------------------------------------------------

c_CALL:		call	expr		; RR2 = ausdruck
		call	@RR2		; UP aufrufen (berechnete Adr.)
		srp	#10h		; RP auf Standard
		ret

;-----------------------------------------------------------------------------
; STOP
;-----------------------------------------------------------------------------

c_STOP:		or	reg_0F, #8	; Bit3 = 1
		ret

;-----------------------------------------------------------------------------
; END
;-----------------------------------------------------------------------------

c_END:		or	reg_0F, #2	; Bit1 = 1
		ret

;-----------------------------------------------------------------------------
; CLRTRP
;-----------------------------------------------------------------------------

c_CLRTRAP:	clr	reg_04		; Trap auf 0 setzen
		clr	reg_05
		ret

;-----------------------------------------------------------------------------
; PRINTHEX "text" ausdruck
;-----------------------------------------------------------------------------

c_PRINTHEX:	call	prnstr		; Ausgabe text
		call	expr		; Ausdruck berechnen
		jr	NC, c_PRINT3	; bei Fehler o. ohne Ausdruck
		call	tohex		; Konvertierung nach Hex-String
					; In Buffer ab #14h
		ld	R10, #5		; 5 Stellen
		jr	c_PRINT1

;-----------------------------------------------------------------------------
; PRINT "text" ausdruck
;-----------------------------------------------------------------------------

c_PRINT:	call	prnstr		; Ausgabe text
		call	expr		; Ausdruck berechnen
		jr	NC, c_PRINT3	; bei Fehler o. ohne Ausdruck keine Ausgabe
		; Ausdruck anzeigen
		call	todez		; Konvertierung nach dezimal 
		ld	R10, #6		; 6 Stellen
c_PRINT1:	ld	R11, #14h	; Konvertierungspuffer
c_PRINT2:	push	R5
		ld	R5, @R11
		inc	R11
		call	putch		; Stelle ausgeben
		pop	R5
		djnz	R10, c_PRINT2
		; Am Ende Zeilenende ausgeben, falls kein Komma
c_PRINT3:	ldc	R6, @RR0
		cp	R6, #','	; folgt Komma?
		jr	NZ, c_PRINT5	; nein -> CR
		incw	RR0
		ldc	R6, @RR0
		cp	R6, #';'	; folgt Kdo-Ende?
		jr	Z, c_PRINT4	; ja -> kein CR ausgeben
		cp	R6, #0Dh	; oder folgt Zeilenende CR?
		jr	Z, c_PRINT4	; dann ebenfalls kein CR ausgeben
		decw	RR0
c_PRINT4:	ret
c_PRINT5:	ld	R5, #0Dh	; CR
		jp	putch		; ausgeben (Zeilenende)

;-----------------------------------------------------------------------------
; INPUT "text" variable
;-----------------------------------------------------------------------------

c_INPUT:	call	prnstr		; Ausgabe text
		call	p_input1	; Abfrage Wert
		call	get_var		; Variablenadresse
		jp	c_LET1		; und Wert zuweisen

;-----------------------------------------------------------------------------
; Einsprung aus BM200 (CONT)
;-----------------------------------------------------------------------------

cont:		ld	reg_0F, #4
		jr	run1

;-----------------------------------------------------------------------------
; Einsprung aus BM200 (STEP)
;-----------------------------------------------------------------------------

step:		ld	reg_0F, #8
		jr	run1

;-----------------------------------------------------------------------------
; RUN
; in 6,7 = Startadr. Basic-Programm
;    8,9 = Adr. Prozedurtabelle (oder 0)
; srp #10h; call $7fd
;-----------------------------------------------------------------------------

; Programmstart
run:		clr	reg_0F
		clr	reg_0E
		ld	R0, reg_06	; RR0 = Startadr. Basic-Programm
		ld	R1, reg_07
		call	c_CLRTRAP	; clear trap
;		
run1:		srp	#10h		; Standard setzen
		pop	reg_0A		; Return-Adresse f. END
		pop	reg_0B
		jr	run3

; nchste Zeile abarbeiten
run2:		tm	reg_0F, #0Ah
		jr	NZ, run4	; END
		tcm	reg_0F, #84h	;-7Ch
		jr	Z, run4	; END

run3:		ldc	R6, @RR0	; R6=Hi(Zeilennummer)+$80
		inc	R6
		djnz	R6, run5
;END		
run4:		jp	@reg_0A		; END bei Zeilenummer > 7Fxxh (32512)

;
run5:		cp	reg_06, R0
		jr	NZ, run6
		cp	reg_07, R1
		jr	Z, run8
; Test auf TRAP		
run6:		ld	R6, reg_04	; TRAP
		or	R6, reg_05
		jr	Z, run8	; =0? kein TRAP
		; TRAP		
		push	R1		; akt. Pogrammpos. sichern
		push	R0
		ld	R0, reg_04	; auf TRAP-Adr. setzen
		ld	R1, reg_05
		call	relop		; logischen Ausdruck auswerten
		jr	Z, run7	; wenn nicht erfllt
		; wenn erfllt
		call	c_CLRTRAP	; TRAP zurcksetzen
		pop	R6		; aktuelle Return-Adr
		pop	R7
		decw	RR6		; vermindern
		push	R7
		push	R6
		incw	RR0		; akt. Pogrammpos. (TRAP) erhhen
		call	c_GOSUB1	; TRAP ausfhren
		jr	run14

; Zeile abarbeiten
run7:		pop	R0
		pop	R1
run8:		incw	RR0		; Zeilennummer bergehen
		incw	RR0
run9:		ldc	R3, @RR0	; erstes Zeichen (Kommando)
		incw	RR0
		cp	R3, #'>'	; ELSE?
		jr	Z, run10	; dann ELSE-Flag beibehalten
		and	reg_0F, #0FEh	; sonst ELSE-Flag rcksetzen (Bit0)
run10:		ld	R6, #HI(tab_kdo) ; Liste der Kommandos
		ld	R7, #LO(tab_kdo)
		clr	R2		; R2=0
run11:		ldc	R8, @RR6
		cp	R8, R3		; Kommando in Liste suchen
		jr	Z, run12	; wenn gefunden
		incw	RR6
		inc	R2
		jr	run11

run12:		add	R2, R2
		ld	R6, #HI(tab_kdo2) ; Adressliste der Kommandos
		ld	R7, #LO(tab_kdo2)
		add	R7, R2
		adc	R6, #0
		ld	R2, #0Ch
		ldci	@R2, @RR6	; Adresse nach reg_0ch
		ldci	@R2, @RR6
run13:		call	@reg_0C		; Kommando aufrufen
;
run14:		ld	R7, #0Dh	; CR Zeilenende?
		call	next_char
		jp	Z, run2		; dann nchste Zeile
		cp	R6, #';'	; Kommandoende?
		jr	Z, run9	; dann nchstes Kommando in Zeile
		;
		jr	run13		; sonst Wiederholung aktuelles Kdo

;-----------------------------------------------------------------------------
; Tabelle der BASIC-Kommandos
;-----------------------------------------------------------------------------

tab_kdo:	db	'L'		; LET
		db	'O'		; PROC
		db	'G'		; GOTO
		db	'F'		; IF..THEN	F..;
		db	'>'		; ELSE		>;
		db	'R'		; RETURN
		db	'S'		; GOSUB
		db	'W'		; WAIT
		db	'M'		; REM
		db	'C'		; CALL
		db	'T'		; STOP
		db	'E'		; END
		db	'!'		; TRAP..TO	!..,
		db	'/'		; CLRTRAP
		db	'P'		; PRINT
		db	'H'		; PRINTHEX
		db	'I'		; INPUT

tab_kdo2:	dw	c_LET
		dw	c_PROC
		dw	c_GOTO
		dw	c_IF
		dw	c_ELSE
		dw	c_RETURN
		dw	c_GOSUB
		dw	c_WAIT
		dw	c_REM
		dw	c_CALL
		dw	c_STOP
		dw	c_END
		dw	c_TRAP
		dw	c_CLRTRAP
		dw	c_PRINT
		dw	c_PRINTHEX
		dw	c_INPUT
		
;-----------------------------------------------------------------------------
; 
;-----------------------------------------------------------------------------
		
		db	0FFh
		db	0FFh

; Eintrittspunkt BASIC-Interpreter
;RUN
		jp	run

; end of 'ROM'

		end
